diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index c523ac235..5299c2583 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -308,46 +329,44 @@ public abstract class OptionsPages {
         );
         DEBUG = register(new OptionsPageDebug("gui.options.page.debug.title", Blocks.BEDROCK.getDefaultStack())
             .withComponent(new OptionsCategory("gui.options.page.debug.category.controls")
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyToggleTextureAtlas))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyToggleDebug))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyShowShortcuts))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyReload))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keySwitchGamemode))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyDumpTextures))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyFullbright))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyLightmaps))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyCollisionBoxes))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyChunkBorders))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyClearChat))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyPauseLostFocus))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyToggleItemInfo))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyReloadChunks))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keySmoothLighting))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyReleaseCursor))
-                .withComponent(new KeyBindingComponent(mc.gameSettings.keyLoadChunksQuickly))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_TOGGLE_TEXTURE_ATLAS))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_TOGGLE_DEBUG))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_SHOW_SHORTCUTS))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_RELOAD))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_SWITCH_GAMEMODE))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_DUMP_TEXTURES))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_FULLBRIGHT))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_LIGHTMAPS))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_COLLISION_BOXES))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_CHUNK_BORDERS))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_CLEAR_CHAT))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_PAUSE_LOST_FOCUS))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_TOGGLE_ITEM_INFO))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_RELOAD_CHUNKS))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_SMOOTH_LIGHTING))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_RELEASE_CURSOR))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_LOAD_CHUNKS_QUICKLY))
             )
             .withComponent(new OptionsCategory("gui.options.page.debug.category.settings")
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.developerMode))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.playerDevModel))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.viewSupportMode))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.alphaMenu))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.lockCamera))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.showDebugScreen))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.showFrameTimes))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.showChunkBorders))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.showCollisionBoxes))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.showItemDebugInfo))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.disableCrashHandler))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.startInFullscreen))
-//                .withComponent(new BooleanOptionComponent(mc.gameSettings.disableShaders))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.loadAllSounds))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.allowSoundOverrides))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.downloadSoundfiles))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.enableDevResourceLoading))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.devModels))
-//                .withComponent(new BooleanOptionComponent(mc.gameSettings.enableMultiDrawRendering))
-                    .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.enableThreadedChunkProvider))
-                    .withComponent(new BooleanOptionComponent(mc.gameSettings.doJCECheck))
+                    .withComponent(new BooleanOptionComponent(GameSettings.DEVELOPER_MODE))
+                    .withComponent(new BooleanOptionComponent(GameSettings.PLAYER_DEV_MODEL))
+                    .withComponent(new BooleanOptionComponent(GameSettings.VIEW_SUPPORT_MODE))
+                    .withComponent(new BooleanOptionComponent(GameSettings.ALPHA_MENU))
+                    .withComponent(new BooleanOptionComponent(GameSettings.LOCK_CAMERA))
+                    .withComponent(new BooleanOptionComponent(GameSettings.SHOW_DEBUG_SCREEN))
+                    .withComponent(new BooleanOptionComponent(GameSettings.SHOW_FRAME_TIMES))
+                    .withComponent(new BooleanOptionComponent(GameSettings.SHOW_CHUNK_BORDERS))
+                    .withComponent(new BooleanOptionComponent(GameSettings.SHOW_COLLISION_BOXES))
+                    .withComponent(new BooleanOptionComponent(GameSettings.SHOW_ITEM_DEBUG_INFO))
+                    .withComponent(new BooleanOptionComponent(GameSettings.DISABLE_CRASH_HANDLER))
+                    .withComponent(new BooleanOptionComponent(GameSettings.START_IN_FULLSCREEN))
+                    .withComponent(new BooleanOptionComponent(GameSettings.LOAD_ALL_SOUNDS))
+                    .withComponent(new BooleanOptionComponent(GameSettings.ALLOW_SOUND_OVERRIDES))
+                    .withComponent(new BooleanOptionComponent(GameSettings.DOWNLOAD_SOUNDFILES))
+                    .withComponent(new BooleanOptionComponent(GameSettings.ENABLE_DEV_RESOURCE_LOADING))
+                    .withComponent(new BooleanOptionComponent(GameSettings.DEV_MODELS))
+                    .withComponent(new ToggleableOptionComponent<>(GameSettings.CHUNK_PROVIDER))
+                    .withComponent(new BooleanOptionComponent(GameSettings.DO_JCE_CHECK))
             )
             .withComponent(new OptionsCategory("gui.options.page.debug.category.utility")
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.model_viewer", () -> {
@@ -424,12 +443,15 @@ public abstract class OptionsPages {
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.crash.soft", () -> {
                     throw new RuntimeException("Test Soft Exception");
                 }))
-                .withComponent(new ShortcutComponent("gui.options.page.debug.button.crash.hard", () -> {
-                    Minecraft.getMinecraft().gameWindow.displayCrashReport(new UnexpectedThrowable("Test Hard Exception", new Error()), -1);
-                    Minecraft.getMinecraft().hasCrashed = true;
-                    throw new Error();
-                }))
+//                .withComponent(new ShortcutComponent("gui.options.page.debug.button.crash.hard", () -> {
+//                    Minecraft.getMinecraft().gameWindow.displayCrashReport(new UnexpectedThrowable("Test Hard Exception", new Error()), -1);
+//                    Minecraft.getMinecraft().hasCrashed = true;
+//                    throw new Error();
+//                }))
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.garbage_collect", System::gc))
+                .withComponent(new ShortcutComponent("gui.options.page.debug.button.reload_commands", () ->{
+                    if (Minecraft.getMinecraft().currentWorld != null) Minecraft.getMinecraft().currentWorld.getCommandManager().reload();
+                }))
             ));
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
index 4c37a4cbd..14b851ca1 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
@@ -2,6 +2,7 @@ package net.minecraft.client.gui.popup;
 
 import it.unimi.dsi.fastutil.ints.IntIntPair;
 import net.minecraft.client.gui.Screen;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import org.jetbrains.annotations.NotNull;
@@ -170,7 +171,7 @@ public final class PopupScreen
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 
         if (this.backgroundColor == null) {
-            final int color = this.mc.gameSettings.guiBackgroundColor.value.getARGB();
+            final int color = GameSettings.GUI_BACKGROUND_COLOR.value.getARGB();
             this.drawGradientRect(0, 0, this.width, this.height, color, color);
         } else {
             this.drawGradientRect(0, 0, this.width, this.height, this.backgroundColor.leftInt(), this.backgroundColor.rightInt());
diff --git a/game/client/src/main/java/net/minecraft/client/gui/server/ScreenSelectServer.java b/game/client/src/main/java/net/minecraft/client/gui/server/ScreenSelectServer.java
index 50e09f2db..82aaec988 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/server/ScreenSelectServer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/server/ScreenSelectServer.java
@@ -9,6 +9,7 @@ import net.minecraft.client.gui.paged.PageRegistry;
 import net.minecraft.client.gui.paged.ScreenPaged;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.client.gui.popup.PopupScreen;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
@@ -252,8 +253,8 @@ public class ScreenSelectServer extends ScreenPaged {
     }
 
     public void joinServer(@NotNull ServerAddress address) {
-        this.mc.gameSettings.lastServer.value = address.toString().replaceAll(":", "_");
-        this.mc.gameSettings.saveOptions();
+        GameSettings.LAST_SERVER.value = address.toString().replaceAll(":", "_");
+        GameSettings.saveOptions();
         this.mc.displayScreen(new ScreenConnecting(this.mc, address.getIP(), address.getPort()));
         freeResources();
     }
@@ -466,7 +467,7 @@ public class ScreenSelectServer extends ScreenPaged {
 
             tessellator.draw();
         } else {
-            final int color = this.mc.gameSettings.guiBackgroundColor.value.getARGB();
+            final int color = GameSettings.GUI_BACKGROUND_COLOR.value.getARGB();
             this.drawGradientRect(0, 0, this.width, this.height, color, color);
             this.drawRect(0, 0, this.width, this.top, 0x5F000000);
             this.drawRect(0, this.bottom, this.width, this.height, 0x5F000000);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/CategoryMobSpawningComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/CategoryMobSpawningComponent.java
new file mode 100644
index 000000000..b610bd657
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/CategoryMobSpawningComponent.java
@@ -0,0 +1,101 @@
+package net.minecraft.client.gui.worldsettings;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.SwitchElement;
+import net.minecraft.client.render.window.CursorShape;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class CategoryMobSpawningComponent extends ButtonComponent {
+    private @Nullable WorldConfiguration worldConfiguration = null;
+    private final @NotNull SwitchElement button;
+    private final @NotNull Type type;
+    public CategoryMobSpawningComponent(@NotNull Type type) {
+        super(type.getKey(), null);
+        this.type = type;
+
+        this.button = new SwitchElement(0, 0, 0, 150, 20, true,
+            I18n.getInstance().translateKey("gui.world_settings.page.mob_spawning.button.on"),
+            I18n.getInstance().translateKey("gui.world_settings.page.mob_spawning.button.off"));
+        this.button.setOn(true);
+    }
+
+    public void setSpawnConfiguration(final @NotNull WorldConfiguration worldConfiguration) {
+        this.worldConfiguration = worldConfiguration;
+    }
+
+    @Override
+    public void resetValue() {
+        this.type.setValue(this.worldConfiguration, true);
+        onChange();
+    }
+
+    @Override
+    public void init(Minecraft mc) {
+        onChange();
+    }
+
+    @Override
+    public boolean isDefault() {
+        return this.button.isOn();
+    }
+
+    protected void onChange() {
+        this.button.setOn(this.type.getValue(this.worldConfiguration));
+    }
+
+    @Override
+    protected void buttonClicked(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) {
+        this.type.setValue(this.worldConfiguration, !this.type.getValue(this.worldConfiguration));
+        onChange();
+    }
+
+    @Override
+    protected void renderButton(final int x, final int y, final int relativeButtonX, final int relativeButtonY, final int buttonWidth, final int buttonHeight, final int relativeMouseX, final int relativeMouseY) {
+        super.renderButton(x, y, relativeButtonX, relativeButtonY, buttonWidth, buttonHeight, relativeMouseX, relativeMouseY);
+
+        this.button.xPosition = x + relativeButtonX;
+        this.button.yPosition = y + relativeButtonY;
+        this.button.width = buttonWidth;
+        this.button.height = buttonHeight;
+
+        this.button.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+
+        if (mc.currentScreen != null && relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
+    }
+
+    public enum Type {
+        HOSTILE("hostile"),
+        PASSIVE("passive");
+
+        private final @NotNull String key;
+
+        Type(@NotNull String key) {
+            this.key = "gui.world_settings.page.mob_spawning." + key;
+        }
+
+        public @NotNull String getKey() {
+            return this.key;
+        }
+
+        public void setValue(@NotNull WorldConfiguration worldConfiguration, boolean flag) {
+            if (this == HOSTILE) {
+                worldConfiguration.getSpawnerConfig().setHostileSpawning(flag);
+            } else {
+                worldConfiguration.getSpawnerConfig().setPassiveSpawning(flag);
+            }
+        }
+
+        public boolean getValue(@NotNull WorldConfiguration worldConfiguration) {
+            if (this == HOSTILE) {
+                return worldConfiguration.getSpawnerConfig().allowHostile;
+            } else {
+                return worldConfiguration.getSpawnerConfig().allowPassive;
+            }
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/EntryMobSpawningComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/EntryMobSpawningComponent.java
new file mode 100644
index 000000000..4116250e8
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/EntryMobSpawningComponent.java
@@ -0,0 +1,73 @@
+package net.minecraft.client.gui.worldsettings;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.SwitchElement;
+import net.minecraft.client.render.window.CursorShape;
+import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Objects;
+
+public class EntryMobSpawningComponent extends ButtonComponent{
+    private final @NotNull EntityDispatcher.EntityDispatcherEntry<?> entry;
+    private @Nullable WorldConfiguration worldConfiguration = null;
+    private final @NotNull SwitchElement button;
+    public EntryMobSpawningComponent(@NotNull EntityDispatcher.EntityDispatcherEntry<?> entry) {
+        super(Objects.requireNonNullElse(entry.nameKey, entry.namespaceID.toString()), null);
+        this.entry = entry;
+
+        this.button = new SwitchElement(0, 0, 0, 150, 20, true,
+            I18n.getInstance().translateKey("gui.world_settings.page.mob_spawning.button.on"),
+            I18n.getInstance().translateKey("gui.world_settings.page.mob_spawning.button.off"));
+        this.button.setOn(true);
+    }
+
+    public void setSpawnConfiguration(final @NotNull WorldConfiguration worldConfiguration) {
+        this.worldConfiguration = worldConfiguration;
+    }
+
+    @Override
+    public void resetValue() {
+        this.worldConfiguration.getSpawnerConfig().setMobSpawn(this.entry.namespaceID, true);
+        onChange();
+    }
+
+    @Override
+    public void init(Minecraft mc) {
+        onChange();
+    }
+
+    @Override
+    public boolean isDefault() {
+        return this.button.isOn();
+    }
+
+    @Override
+    protected void buttonClicked(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) {
+        this.worldConfiguration.getSpawnerConfig().setMobSpawn(this.entry.namespaceID, this.worldConfiguration.getSpawnerConfig().canMobSpawn(this.entry.namespaceID));
+        onChange();
+    }
+
+    protected void onChange() {
+        this.button.setOn(this.worldConfiguration.getSpawnerConfig().canMobSpawn(this.entry.namespaceID));
+    }
+
+    @Override
+    protected void renderButton(final int x, final int y, final int relativeButtonX, final int relativeButtonY, final int buttonWidth, final int buttonHeight, final int relativeMouseX, final int relativeMouseY) {
+        super.renderButton(x, y, relativeButtonX, relativeButtonY, buttonWidth, buttonHeight, relativeMouseX, relativeMouseY);
+
+        this.button.xPosition = x + relativeButtonX;
+        this.button.yPosition = y + relativeButtonY;
+        this.button.width = buttonWidth;
+        this.button.height = buttonHeight;
+
+        this.button.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+
+        if (mc.currentScreen != null && relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ScreenWorldSettings.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ScreenWorldSettings.java
index 87c7514f6..3baacf81f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ScreenWorldSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ScreenWorldSettings.java
@@ -8,6 +8,8 @@ import net.minecraft.client.gui.paged.ScreenPaged;
 import net.minecraft.core.data.gamerule.GameRule;
 import net.minecraft.core.data.gamerule.GameRuleBoolean;
 import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.world.settings.WorldConfiguration;
 import org.jetbrains.annotations.NotNull;
@@ -16,10 +18,10 @@ import org.jetbrains.annotations.Nullable;
 import java.util.List;
 
 public class ScreenWorldSettings
-    extends ScreenPaged
-{
+    extends ScreenPaged {
     public static final @NotNull PageRegistry CREATE_WORLD_PAGES = new PageRegistry();
     public static final @NotNull Page PAGE_GAME_RULES = CREATE_WORLD_PAGES.register(new Page("gui.world_settings.page.game_rules.title", Items.PAPER.getDefaultStack()));
+
     static {
         for (final @NotNull GameRule<?> gameRule : Registries.GAME_RULES) {
             if (gameRule instanceof GameRuleBoolean) {
@@ -27,29 +29,55 @@ public class ScreenWorldSettings
             }
         }
     }
+
     public static final @NotNull Page PAGE_WORLD_SETTINGS = CREATE_WORLD_PAGES.register(
-            new Page("gui.world_settings.page.world_settings.title", Items.PAINTBRUSH.getDefaultStack())
-                    .withComponent(new WorldTypeButtonComponent("gui.world_settings.label.world_type", null))
+        new Page("gui.world_settings.page.world_settings.title", Items.PAINTBRUSH.getDefaultStack())
+            .withComponent(new WorldTypeButtonComponent("gui.world_settings.label.world_type", null))
+            .withComponent(new StartingBiomeButtonComponent("gui.world_settings.label.starting_biome", null))
+    );
+    public static final @NotNull Page PAGE_MOB_SPAWNING = CREATE_WORLD_PAGES.register(
+        new Page("gui.world_settings.page.mob_spawning.title", Items.EGG_CHICKEN.getDefaultStack())
+            .withComponent(new CategoryMobSpawningComponent(CategoryMobSpawningComponent.Type.HOSTILE))
+            .withComponent(new CategoryMobSpawningComponent(CategoryMobSpawningComponent.Type.PASSIVE))
     );
 
+    static {
+        for (var entry : EntityDispatcher.getInstance().entries) {
+            if (Mob.class.isAssignableFrom(entry.entityClass) && entry.nameKey != null) { // Probably have something better than checking if name key is null
+                PAGE_MOB_SPAWNING.withComponent(new EntryMobSpawningComponent(entry));
+            }
+        }
+    }
+
     private final @NotNull WorldConfiguration worldConfiguration;
 
     public ScreenWorldSettings(final @Nullable Screen parent, final @NotNull WorldConfiguration worldConfiguration) {
-        super(parent, CREATE_WORLD_PAGES, PAGE_GAME_RULES, "gui.world_settings.label.title", new String[] { "gui.world_settings.button.done" });
+        super(parent, CREATE_WORLD_PAGES, PAGE_GAME_RULES, "gui.world_settings.label.title", new String[]{"gui.world_settings.button.done"});
 
         this.worldConfiguration = worldConfiguration;
 
         final List<PageComponent> gameRulesPageComponents = PAGE_GAME_RULES.getComponents();
-        for (final @NotNull  PageComponent component : gameRulesPageComponents) {
-            if (component instanceof BooleanGameRuleComponent) {
-                ((BooleanGameRuleComponent) component).setGameRuleCollection(worldConfiguration.getGameRuleCollection());
+        for (final @NotNull PageComponent component : gameRulesPageComponents) {
+            if (component instanceof BooleanGameRuleComponent ruleComponent) {
+                ruleComponent.setGameRuleCollection(worldConfiguration.getGameRuleCollection());
             }
         }
 
         final List<PageComponent> worldSettingsPageComponents = PAGE_WORLD_SETTINGS.getComponents();
         for (final @NotNull PageComponent component : worldSettingsPageComponents) {
-            if (component instanceof WorldTypeButtonComponent) {
-                ((WorldTypeButtonComponent) component).setWorldConfiguration(worldConfiguration);
+            if (component instanceof WorldTypeButtonComponent typeButtonComponent) {
+                typeButtonComponent.setWorldConfiguration(worldConfiguration);
+            } else if (component instanceof StartingBiomeButtonComponent startingBiomeButtonComponent) {
+                startingBiomeButtonComponent.setWorldConfiguration(worldConfiguration);
+            }
+        }
+
+        final List<PageComponent> mobSpawnPageComponents = PAGE_MOB_SPAWNING.getComponents();
+        for (final @NotNull PageComponent component : mobSpawnPageComponents) {
+            if (component instanceof EntryMobSpawningComponent mobSpawningComponent) {
+                mobSpawningComponent.setSpawnConfiguration(worldConfiguration);
+            } else if (component instanceof CategoryMobSpawningComponent categoryComponent) {
+                categoryComponent.setSpawnConfiguration(worldConfiguration);
             }
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/StartingBiomeButtonComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/StartingBiomeButtonComponent.java
new file mode 100644
index 000000000..fe9c119b5
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/StartingBiomeButtonComponent.java
@@ -0,0 +1,121 @@
+package net.minecraft.client.gui.worldsettings;
+
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.popup.PopupBuilder;
+import net.minecraft.client.gui.popup.PopupScreen;
+import net.minecraft.client.render.window.CursorShape;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import net.minecraft.core.world.type.WorldTypeGroups;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Objects;
+
+public class StartingBiomeButtonComponent
+    extends ButtonComponent {
+    private @Nullable WorldConfiguration worldConfiguration = null;
+    private final @NotNull ButtonElement button;
+    private @Nullable WorldTypeGroups.Group lastGroup = null;
+
+    public StartingBiomeButtonComponent(final @NotNull String translationKey, final @Nullable String tooltipTranslationKey) {
+        super(translationKey, tooltipTranslationKey);
+
+        this.button = new ButtonElement(0, 0, 0, 150, 20, "");
+    }
+
+    public void setWorldConfiguration(final @NotNull WorldConfiguration worldConfiguration) {
+        this.worldConfiguration = worldConfiguration;
+        Biome biome = this.worldConfiguration.getStartingBiome();
+        this.button.displayString = I18n.getInstance().translateKey(biome == null ? "gui.world_settings.page.starting_biome.biome.none" : biome.translationKey);
+    }
+
+    @Override
+    public void resetValue() {
+        Objects.requireNonNull(this.worldConfiguration).setStartingBiome(null);
+        Biome biome = this.worldConfiguration.getStartingBiome();
+        this.button.displayString = I18n.getInstance().translateKey(biome == null ? "gui.world_settings.page.starting_biome.biome.none" : biome.translationKey);
+    }
+
+    @Override
+    public boolean isDefault() {
+        return Objects.requireNonNull(this.worldConfiguration).getStartingBiome() == null;
+    }
+
+    @Override
+    protected void buttonClicked(final int mouseButton, final int x, final int y, final int width, final int height, final int relativeMouseX, final int relativeMouseY) {
+        final I18n i18n = I18n.getInstance();
+
+        Biome[] biomes = this.worldConfiguration.getWorldTypeGroup().get(Dimension.OVERWORLD).allBiomes();
+
+        final @NotNull String @NotNull [] keys = new String[biomes.length + 1];
+        for (int i = 0; i < keys.length; i++) {
+            int selected = i - 1;
+
+            Biome biome;
+            if (selected >= 0) {
+                biome = biomes[selected];
+            } else {
+                biome = null;
+            }
+
+            keys[i] = i18n.translateKey(biome == null ? "gui.world_settings.page.starting_biome.biome.none" : biome.translationKey);
+        }
+
+        int b = 0;
+        if (this.worldConfiguration.getStartingBiome() == null) {
+            b = 0;
+        } else {
+            for (int i = 0; i < biomes.length; i++) {
+                if (biomes[i] == this.worldConfiguration.getStartingBiome()) {
+                    b = i + 1;
+                    break;
+                }
+            }
+        }
+
+        final PopupScreen popup = new PopupBuilder(Objects.requireNonNull(mc.currentScreen), 150)
+            .closeOnEsc(0)
+            .closeOnClickOut(0)
+            .withLabel("gui.world_settings.label.starting_biome")
+            .withList("biomeList", 140, keys, null, b, true)
+            .withOnCloseListener((statusCode, results) -> {
+                if (statusCode == 1) {
+                    int selected = (Integer) results.get("biomeList") - 1;
+                    Biome biome;
+                    if (selected >= 0) {
+                        biome = biomes[selected];
+                    } else {
+                        biome = null;
+                    }
+                    this.worldConfiguration.setStartingBiome(biome);
+                    this.button.displayString = I18n.getInstance().translateKey(biome == null ? "gui.world_settings.page.starting_biome.biome.none" : biome.translationKey);
+                }
+            })
+            .build();
+        mc.displayScreen(popup);
+    }
+
+    @Override
+    protected void renderButton(final int x, final int y, final int relativeButtonX, final int relativeButtonY, final int buttonWidth, final int buttonHeight, final int relativeMouseX, final int relativeMouseY) {
+        if (worldConfiguration.getWorldTypeGroup() != lastGroup) {
+            lastGroup = worldConfiguration.getWorldTypeGroup();
+            resetValue();
+        }
+
+        super.renderButton(x, y, relativeButtonX, relativeButtonY, buttonWidth, buttonHeight, relativeMouseX, relativeMouseY);
+
+        this.button.xPosition = x + relativeButtonX;
+        this.button.yPosition = y + relativeButtonY;
+        this.button.width = buttonWidth;
+        this.button.height = buttonHeight;
+
+        this.button.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+
+        if (mc.currentScreen != null && relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            mc.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
+    }
+}
